#ifndef __pxx_fd_binary_stream_hh__
#define __pxx_fd_binary_stream_hh__

#include "pxx_binary_stream.hh"
#include "pxx_fd_buffer.hh"

namespace pxx
{

class FD_BinaryStream :
  public BinaryStream,
  public FD_Buffer
{

public:

  inline FD_BinaryStream (
    int _fd, io_mode_t _mode, size_t _bufsize = Buffer::default_size
  ) ;

  inline ~FD_BinaryStream () ;

  inline FD_BinaryStream& flush () ;

  void put (char _c) ;
  void get (char& _c) ;
  void unget (char _c) ;
  size_t read (void* _buf, size_t _len) ;
  size_t write (void* _buf, size_t _len) ;

};

}

#endif // __pxx_fd_binary_stream_hh__
