#ifndef __pxx_vector_hh__
#define __pxx_vector_hh__

#include "pxx_common.hh"
#include "pxx_exception.hh"

namespace pxx
{

template <typename type_t>
class Vector
{

private:

  type_t* data ;
  size_t length ;
  size_t capacity ;

public:

  Vector (size_t _length = 0) ;
  Vector (Vector const& _s) ;
  ~Vector () ;
  Vector& operator = (Vector const& _s) ;

  type_t const* get_data () const ;

  void expand (size_t _extra) ;
  void decrease (size_t _extra);
  type_t const& operator [] (size_t _index) const ;
  type_t& operator [] (size_t _index) ;
  size_t get_length () const ;
  size_t get_capacity () const ;

};

}

#endif // __pxx_vector_hh__
