//
// Copyright (C) 2000 Refal+ Development Group
//
// Refal+ is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Refal+ is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Refal+; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// $Source$
// $Revision: 2187 $
// $Date: 2006-12-15 03:17:56 +0300 (Fri, 15 Dec 2006) $
// Author: Andrey Slepuhin <pooh@msu.ru>

#ifndef __rf_arg_hh__
#define __rf_arg_hh__

#include "rf_expr.ih"
#include "rf_stack.ih"

namespace rfrt
{

class Arg :
  public Expr
{

private:

  inline Arg (Arg const&) :
    Expr ()
  {
    FATAL("Private constructor Arg(Arg const&) should never be called");
  }

  inline Arg& operator = (Arg const&)
  {
    FATAL("Private operator = Arg(Arg const&) should never be called");
    return *this;
  }

public:

  inline Arg () :
    Expr (stack->get())
  {}

  inline ~Arg ()
  {
#ifndef RFRT_STINGY_STACK
    if (__keep_stack && mem_chunk)
      mem_chunk->inc_ref_count();
#endif
  }

};

}

#endif // __rf_arg_hh__
