#ifndef __rf_box_hh__
#define __rf_box_hh__

#include "rf_symbol.ih"
#include "rf_expr.ih"
#include "rf_sysdefs.hh"

namespace rftype
{

class BoxContents : public Expr
{
  public:

    BoxContents () : Expr()
    {}
    
    BoxContents (Expr const& _e) : Expr(_e)
    {}
    
    Expr& operator = (Expr const& _e)
    {
      return Expr::operator=(_e);
    };
};

RF_NEW_SYMBOL(BoxContents, ObjectTerm);
RF_NEW_SYMBOL(NamedObject<BoxContents>, ObjectTerm);

template <>
inline pxx::WString RF_SYMBOL(BoxContents)::to_string (RF_SYMBOL(BoxContents) const* _s)
{ 
  size_t max_len = hex_ptr_len + 10;
  wchar_t* str = static_cast<wchar_t*>(alloca(max_len * sizeof(wchar_t)));
  Expr* ptr = _s->get_obj_ptr();
  int len = swprintf(str, max_len, L"<Box|%p|", ptr);
  if (-1 == len)
    FATAL("<Box|%p| is more then %u wide characters", ptr, max_len);
  return pxx::WString(str, len) + pxx::WString(*ptr) + pxx::WString(L">");
}

}

#endif // __rf_box_hh__
