// $Id: rf_closure.hh 2187 2006-12-15 00:17:56Z orlov $

#ifndef __rf_closure_hh__
#define __rf_closure_hh__

#include "rf_symbol.hh"
#include "rf_func.hh"
#include "rf_expr.hh"

namespace rftype
{

using namespace rfrt;

class Closure
{

  Func* func;

  struct Arg
  {
    Arg* prev;
    Expr expr;
    Arg (Arg* _prev, Expr const& _expr) : prev(_prev), expr(_expr) {};
  };

  Arg* args;
  Arg* current_arg;

  NO_COPY_CTOR(Closure)
  NO_ASSIGN(Closure)

public:

  inline Closure (Func* _func) ;

  inline ~Closure () ;

  inline void push_arg (Expr const& _expr) ;
  inline Expr const* pop_arg () ;

  inline Func const* get_func () const ;

  inline bool operator == (Closure const& _c) const ;
  static inline int compare (Closure const& _c1, Closure const& _c2) ;

  struct InitParams : public Expr
  {
    inline InitParams () ;
  };
};

}

#endif // __rf_closure_hh__
