// $Source$
// $Revision: 2270 $
// $Date: 2007-01-22 17:20:03 +0300 (Mon, 22 Jan 2007) $

#ifndef __rf_common_hh__
#define __rf_common_hh__

#include "pxx_common.hh"
#include "pxx_heap_allocator.hh"
#include "pxx_chunk_allocator.hh"

#include "assert.h"

namespace rfrt
{

#ifdef ALL_INLINE
#define INLINE inline
#else
#define INLINE
#endif

static const uint32_t hash_size = 1024 ;
static uintptr_t const default_heap_size = uintptr_t(1ULL << 25) ;
extern uintptr_t heap_size ;
extern void* heap_start ;
extern pxx::HeapAllocator* allocator ;
static uintptr_t const default_stack_size = uintptr_t(1ULL << 24) ;
extern uintptr_t stack_size ;
extern void* stack_start ;
extern bool init_done ;
extern bool use_rts ;
extern bool trap_stack_on ;

static const unsigned temp_string_len = 128;
extern wchar_t temp_string[];

#if UINTPTR_MAX == UINT32_MAX
static const uint8_t hex_ptr_len = 8;
#elif UINTPTR_MAX == UINT64_MAX
static const uint8_t hex_ptr_len = 16;
#else
#error "Unsupported pointer size"
#endif

static const uint8_t max_int_len = 10;
// FIXME: Is int 32 bits everywhere?

#if DEBUG
extern uintptr_t empty_copy ;
extern uintptr_t lt_copy ;
extern uintptr_t rt_copy ;
extern uintptr_t both_copy ;
extern uintptr_t unifications ;
extern uintptr_t identical ;
#endif

#ifdef TRACE_EXEC // trace of execution is wanted
#   define D(x)   x
#else
#   define D(x)
#endif

//inline bool is_refal_alnum (wint_t _wc) ;
//inline bool is_refal_upper (wint_t _wc) ;

struct static_object_t {};
extern const static_object_t static_object;

#ifdef RFRT_WITHOUT_MPINT
#define RFRT_WITHOUT_GMP
#endif

}

#endif // __rf_common_hh__
