//
// Copyright (C) 2000 Refal+ Development Group
//
// Refal+ is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Refal+ is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Refal+; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// $Source$
// $Revision: 2270 $
// $Date: 2007-01-22 17:20:03 +0300 (Mon, 22 Jan 2007) $
// Author: Andrey Slepuhin <pooh@msu.ru>

#ifndef __rf_core_hh__
#define __rf_core_hh__

#include "pxx_heap_allocator.ih"
#include "pxx_chunk_allocator.ih"
#include "pxx_common.ih"
#include "pxx_sys_error.ih"

#include "rf_common.hh"
#include "rf_term.ih"
#include "rf_expr.ih"
#include "rf_stack.ih"
#include "rf_arg.hh"
#include "rf_result.hh"
#include "rf_retval.ih"
#include "rf_macros.hh"
#include "rf_memory_chunk.hh"
#include "rf_atstart.hh"
#include "rf_char.ih"
#include "rf_short_int.ih"
#include "rf_integer.ih"
#include "rf_mpint.hh"
#include "rf_word.ih"
#include "rf_vector.ih"
#include "rf_channel.ih"
#include "rf_func.ih"
#include "rf_closure.ih"
#include "rf_table.ih"
#include "rf_string.ih"
#include "rf_static_object.ih"
#include "rf_symbol.ih"
#include "rf_box.hh"

namespace rfrt
{

extern rftype::Func* entry ;

class Entry
{
public:
  Entry (rftype::Func* _entry) { rfrt::entry = _entry; }
};

extern void (*init_StdIn)();

class InitStdIn
{
public:
  InitStdIn (void (*_init_StdIn)()) { init_StdIn = _init_StdIn; }
};

extern int argc ;
extern char** argv ;

extern int breakc ;
extern char** breakv ;

}

#endif // __rf_core_hh__
