// $Id: rf_mpint.hh 2187 2006-12-15 00:17:56Z orlov $

#ifndef __rf_mpint_hh__
#define __rf_mpint_hh__

#include "rf_symbol.ih"

namespace rftype
{

using namespace rfrt;

class MPInt
{

  long *number;
  unsigned long  len;

public:

  static MPInt add (MPInt const& n1, MPInt const& n2);

  static MPInt sub (MPInt const& n1, MPInt const& n2);

  static MPInt mul (MPInt const& n1, MPInt const& n2);

  void invert () const;

  static bool eq (MPInt const& n1, MPInt const& n2);

  static int compare (MPInt const& n1, MPInt const& n2);

  pxx::WString to_string () const;
};


RF_NEW_SYMBOL(MPInt, ObjectTerm);

template<>
inline bool RF_SYMBOL(MPInt)::eq (
    RF_SYMBOL(MPInt) const* _s1, RF_SYMBOL(MPInt) const* _s2
)
{ 
  return MPInt::eq(_s1->get_object(), _s2->get_object());
}

template<>
inline int RF_SYMBOL(MPInt)::compare (
    RF_SYMBOL(MPInt) const* _s1, RF_SYMBOL(MPInt) const* _s2
)
{ 
  return MPInt::compare(_s1->get_object(), _s2->get_object());
}

template<>
inline pxx::WString RF_SYMBOL(MPInt)::to_string (RF_SYMBOL(MPInt) const* _s)
{ 
  return _s->get_object().to_string();
}

}

#endif // __rf_mpint_hh__
