// $Source$
// $Revision: 2187 $
// $Date: 2006-12-15 03:17:56 +0300 (Fri, 15 Dec 2006) $
// $Author: orlov $

#ifndef __rf_object_ref_hh__
#define __rf_object_ref_hh__

#include "rf_types.hh"
#include "rf_term.hh"
#include "rf_object.hh"

namespace rftype
{

using namespace rfrt ;

class ObjectRef :
  public Term
{

  NO_COPY_CTOR(ObjectRef)
  NO_ASSIGN(ObjectRef)

public:

  inline ObjectRef (Object* _obj_ptr) ;

  inline ~ObjectRef () ;

  inline Object* get_obj_ptr () const ;

  static void ctor (ObjectRef* _to, ObjectRef const* _from) ;
  static void dtor (ObjectRef* _ref) ;
  static bool eq (ObjectRef const* _ref1, ObjectRef const* _ref2) ;
  static int compare (ObjectRef const* _ref1, ObjectRef const* _ref2) ;
  static uint32_t hash (ObjectRef const* _ref) ;
  static pxx::WString to_string (ObjectRef const* _ref) ;
  static short_type_funcs_t funcs ;
  static TypeRegister reg ;

  ///
  /// Term class for template instantiations
  static const term_class_t term_class = short_term;
};

}

#endif // __rf_object_ref_hh__

