//
// Copyright (C) 2000 Refal+ Development Group
//
// Refal+ is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Refal+ is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Refal+; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// $Source$
// $Revision: 2187 $
// $Date: 2006-12-15 03:17:56 +0300 (Fri, 15 Dec 2006) $
// Author: Andrey Slepuhin <pooh@msu.ru>

#ifndef __rf_retval_hh__
#define __rf_retval_hh__

#include "rf_expr.hh"
#include "rf_func.hh"

namespace rfrt
{

class RetVal ;
typedef RetVal (*rf_func_t)() ;

class RetVal
{

private:

  uintptr_t data;

public:

  inline RetVal (rftype::Func const* _f) :
    data ((uintptr_t)_f)
  {}

  inline RetVal (bool _b = true) ;

  inline RetVal (Expr* _saved_top) ;

  inline ~RetVal ()
  {}

  inline operator bool () const ;

  inline bool is_tail () const ;

  inline rftype::Func* get_ptr () const ;

};

}

#endif // __rf_retval_hh__
