// $Source$
// $Revision: 2187 $
// $Date: 2006-12-15 03:17:56 +0300 (Fri, 15 Dec 2006) $
// $Author: orlov $

#ifndef __rf_short_int_hh__
#define __rf_short_int_hh__

#include "rf_types.hh"
#include "rf_expr.hh"
#include "rf_term.hh"

namespace rftype
{

using namespace rfrt;

class Int32 :
  public Term
{

  static unsigned compute_max_len () ;

public:
  ///
  /// Exceptions
  class Error {};
  class InvalidParameter : public Error {};
  class OutOfMemory : public Error {};

  static const unsigned max_len;

  static inline Expr create_expr (intptr_t _n) ;
  static inline Expr create_expr (char const* _n) ;
  static inline Expr create_expr (pxx::WString& _str) ;

  inline Int32 (intptr_t n) ;
  inline Int32 (char const* _str) ;
  inline intptr_t to_int () const ;

  inline int cmp (size_t _n) const ;

  inline size_t get_char_len () const ;

  static void ctor (Int32* _to, Int32 const* _from) ;
  static int compare (Int32 const* _shint1, Int32 const* _shint2) ;
  static uint32_t hash (Int32 const* _shint) ;
  static pxx::WString to_string (Int32 const* _shint) ;
  static short_type_funcs_t funcs ;
  static TypeRegister reg ;

  ///
  /// Term class for template instantiations
  static const term_class_t term_class = flat_term;
};

}

#endif // __rf_short_int_hh__
