//
// Copyright (C) 2000 Refal+ Development Group
//
// Refal+ is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Refal+ is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Refal+; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// $Source$
// $Revision: 2187 $
// $Date: 2006-12-15 03:17:56 +0300 (Fri, 15 Dec 2006) $

#ifndef __rf_stack_hh__
#define __rf_stack_hh__

#include "rf_expr.hh"
#include "rf_func.hh"
#include "pxx_heap.ih"

namespace rfrt
{

class RetVal ;

class Stack :
  public pxx::Heap
{

  friend class Result ;

private:

  Expr* last;
  Expr* top ;

  Expr* saved_top;
  intptr_t args_num;

  uintptr_t depth;

public:

  inline Stack (void* const _start, size_t _size) :
    pxx::Heap (_size, _size, _start),
    last (static_cast<Expr*>(start_addr) + _size/sizeof(Expr)),
    top (static_cast<Expr*>(start_addr)),
    depth (0)
  {}

  inline ~Stack ()
  {}

  inline void push ()
  {}

  inline void push (Expr const& _expr) ;

  inline void pop ()
  {}
  
  inline void pop (Expr& _expr) ;

  inline void pop (Result& _res) ;

  inline Expr const* get () ;

  inline Expr* get_top () ;

  inline void set_top (Expr* _top) ;

  inline void destroy_results (Expr* _saved_top, size_t _saved_depth) ;

  inline void destroy_results () ;

  inline void cleanup (size_t _saved_depth) ;

  inline void start_push_mode () ;

  inline void stop_push_mode () ;

  inline void start_ress_mode () ;

  inline void stop_ress_mode (rftype::Func const* _f) ;

  inline void start_pop_mode () ;

  inline void start_pop_mode (Expr* const __rf_call_saved_top) ;

  inline void stop_pop_mode () ;

  inline bool is_in_push_mode () const ;

  inline Expr* get_upper (size_t _offset) const ;

  inline void up () ;

  inline void inc_depth () ;

  inline void dec_depth () ;

  inline size_t get_depth () const ;

  inline rftype::Func* get_func (size_t _depth) const ;

  inline int get_args (size_t _depth, Expr** _args) const ;

  inline static rftype::Func* getf (Expr const* _p) ;

  inline static int getn (Expr const* _p) ;

  inline static Expr const* geta (Expr const* _p) ;

  inline static Expr const* getup (Expr const* _p) ;

  inline Expr get_part (size_t _offset, size_t _len) const ;

  inline void dump () const ;

};

extern Stack* stack ;

}

#endif // __rf_stack_hh__
