#ifndef __rf_vector_hh__
#define __rf_vector_hh__

#include "rf_object.hh"
#include "rf_expr.hh"
#include "pxx_vector.hh"

namespace rftype
{

using namespace rfrt ;

class Vector :
  public Object, public pxx::Vector<Expr>
{

private:

  static ObjectRegister reg ;

public:

  inline Vector (size_t _length = 0) ;
  inline Vector (size_t _length, Expr const& _fill) ;
  inline Vector (Expr const& _expr, size_t _length) ;
  inline Vector (Vector const& _vector, size_t _index, size_t _length) ;
  inline Vector (Vector const& _vector) ;

  inline unsigned get_type () const ;
  inline uint32_t hash () const ;

  inline const Vector& operator = (Vector const&) ;

  inline pxx::WString to_string () const ;
};

}

#endif // __rf_vector_hh__
